"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _acorn = require("acorn");

var _acornWalk = require("acorn-walk");

var _fs = _interopRequireDefault(require("fs"));

var _util = require("util");

var _prettier = _interopRequireDefault(require("prettier"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const schema = {
//   type: 'object',
//   properties: {},
// }
var loader = function loader(content, sourceMap) {
  var callback = this.async();
  var declarationPath = this.resourcePath + '.d.ts';
  var parsed = (0, _acorn.parse)(content, {
    sourceType: 'module'
  });
  var keys = [];
  (0, _acornWalk.simple)(parsed, {
    Property: function Property(node) {
      keys.push(node.key.value);
    },
    ExportNamedDeclaration: function ExportNamedDeclaration(node) {
      (0, _acornWalk.simple)(node, {
        VariableDeclarator: function VariableDeclarator(node) {
          keys.push(node.id.name);
        }
      });
    }
  });
  var declarations = keys.map(function (key) {
    return "".concat(key, ": string;");
  }).join('\n');
  var fileContent = "\n  interface CSSModules {\n    ".concat(declarations, "\n  }\n  export const cssModules: CSSModules\n  export default cssModules\n");

  var formattedContent = _prettier.default.format(fileContent, {
    parser: 'typescript'
  });

  (0, _util.promisify)(_fs.default.writeFile)(declarationPath, formattedContent, {
    encoding: 'utf-8'
  }).then(function () {
    callback(undefined, content);
  }).catch(function (err) {
    // istanbul ignore next
    callback(err, content);
  });
};

var _default = loader;
exports.default = _default;